%this code is provided as-is without any warranty or indemnification of any kind. 
%for any problem please contact me: e-mail adress: valedido@unina.it
%if you are using it please cite:
%Di Donato,V., Jamka. J., Martn-Fernndez J.A. 2020 - Compositional regression-based methods for SST reconstruction
%Alpine and Mediterranean Quaternary,... 

%inverse clr tranformation
%chiusura is the closure constant i.e. 1 , 100 etc

%inversa della clr
%chiusura sceglie la costante di chiusura (a 1 o 100 etc)
function clrinv=clrinversa(datilogcentrati,chiusura)
[N P]=size(datilogcentrati);
%calcola l'esponenziale
clrinv=exp(datilogcentrati);
% e chiude a chiusura
somma=sum(clrinv,2);
for i=1:N
clrinv(i,:)=clrinv(i,:)*chiusura./somma(i,1);
end
end


