%this code is provided as-is without any warranty or indemnification of any kind. 
%for any problem please contact me: e-mail adress: valedido@unina.it
%if you are using it please cite:
%Di Donato,V., Jamka. J., Martn-Fernndez J.A. 2020 - Compositional regression-based methods for SST reconstruction
%Alpine and Mediterranean Quaternary,... 

%compute the inverse of ILR transformation 
%     x=C(exp(ILR*PSI)

%datilr is a N x D-1 dataset
%PSI is matrix obtained from ilrprogr or balances
%chiusura   is the closure constant
%composizione is the reconstructed compositional dataset (N x D)
%the composition also computes the CLR data (composizioneclr)

%calcola l'inversa di ILR basandosi sulla matrice PSI
%dati: datiilr sono N*D-1 (SENZA colonna di intestazione). La matrice PSI  D-1 per D
%chiusura  la costante di chiusura dei dati (1,100, ppm etc)
%La formula  x=C(exp(ILR*PSI)
%calcola anche i dati clr

%esempio: [composizione,composizioneclr]=ilrinversa(datiilr,PSI,100)
function [composizione,composizioneclr]=ilrinversa(datiilr,PSI,chiusura)
[n,p]=size(datiilr);
composizioneclr=datiilr*PSI;
composizione=exp(composizioneclr)
%somma=sum(composizione,2);
for i=1:n
    composizione(i,:)=composizione(i,:).*chiusura./sum(composizione(i,:),2);
end
end