%this code is provided as-is without any warranty or indemnification of any kind. 
%for any problem please contact me: e-mail adress: valedido@unina.it
%if you are using it please cite:
%Di Donato,V., Jamka. J., Martn-Fernndez J.A. 2020 - Compositional regression-based methods for SST reconstruction
%Alpine and Mediterranean Quaternary,... 

%this function extract from data a submatrix by comparing the text_data and text_subcompo strings
%text_data is the header of the data matrix, and text_sumcompo the header
%string of the extracted matrix
%N.B. beware that the headers are written exactly in the same way!

%la funzione compara stringhe di intestazione. Se coincidono crea una
%colonna con i valori della matrice di origine
%Gli argomenti sono: 1)la matrice dei dati 2) la stringa dai dati 3) Quella
%che f da riferimento) (che serve a creare il risultato)
%esempio di utilizzo:
%ridotta=estrai(data,text_data,text_subcompo)
function ridotta=estrai(data,text_data,text_subcompo)
[w y]=size(data);
[c a]=size(text_data);
[d b]=size(text_subcompo);
ridotta=zeros(w,b);
if isnumeric(text_data)==0
    for i=1:b
        for j=1:a
            if strcmp(text_subcompo(1,i),text_data(1,j))==1
            ridotta(:,i)=data(:,j);
            else
            end
        end
    end
    for i=1:b
        for j=1:a
        PPP(i,j)=strcmp(text_subcompo(1,i),text_data(1,j));
        end
    end
    notextnum=[];
    notext={};
    for i=1:b
        if all(PPP(i,:)==0)
        notextnum(i,1)=i;    
        notext(i,1)=text_subcompo(1,i);
        else
        end 
    end       
    if any(notextnum~=0)
    zz=find(notextnum)
    [u uu]=size(zz);
        for i=1:u
        notext2(i,1)=notext(zz(i,1),1);
        end
    'controlla le colonne seguenti!'
    colonne=nonzeros(notextnum)
    'corrispondenti alle intestazioni'
    variabili=notext2
    end
elseif isnumeric(text_data)==1
PPP=zeros(b,a);
    for i=1:b
        for j=1:a
            if text_subcompo(1,i)==text_data(1,j);
            ridotta(:,i)=data(:,j);
            PPP(i,j)=1;
            else
            end
        end
    end
%     for i=1:b
%         for j=1:a
%         PPP(i,j)=strcmp(text_ridotta(1,i),text_completa(1,j));
%         end
%     end
    notextnum=[];
    notext=[];
    for i=1:b
        if all(PPP(i,:)==0)
        notextnum(i,1)=i;    
        notext(i,1)=text_subcompo(1,i);
        else
        end 
    end       
    if any(notextnum~=0)
    zz=find(notextnum);
    [u uu]=size(zz);
        for i=1:u
        notext2(i,1)=notext(zz(i,1),1);
        end
    'controlla le colonne seguenti!'
    colonne=nonzeros(notextnum)
    'corrispondenti alle intestazioni'
    variabili=notext2
    end
end
end