%compute percentages from counts
%N.B. the first column of data must include ID, age or depth of samples
%con_o_senza   can be 'con' o 'senza'. Use 'con' if the last column of data
%              include the total of counts, instead use 'senza'

%trasforma conteggi in percentuali
%N.B. nella funzione  considerata una prima colonna di intestazione (cm o anni)
%con_o_senza indica se l'ultima colonna contiene il totale o no; si pu
%mettere:
%       'con' o 'senza'
%esempio di utilizzo
%perc=percentuali(data,'con')
function perc=percentuali(dati,con_o_senza)
[n p]=size(dati);
switch con_o_senza
case 'con'
somma=dati(:,p);
perc=zeros(n,p-1);
perc(:,1)=dati(:,1);
    for i=2:(p-1)
    perc(:,i)=dati(:,i)*100./somma;    
    end
case 'senza'
somma=sum(dati(:,2:p),2);
perc=zeros(n,p);
perc(:,1)=dati(:,1);
    for i=2:p
    perc(:,i)=dati(:,i)*100./somma;    
    end
end