%this code is provided as-is without any warranty or indemnification of any kind. 
%for any problem please contact me: e-mail adress: valedido@unina.it
%if you are using it please cite:
%Di Donato,V., Jamka. J., Martn-Fernndez J.A. 2020 - Compositional regression-based methods for SST reconstruction
%Alpine and Mediterranean Quaternary,...

%   Average of the values of vector x weighted on the inverse of the values of a vector y
% N.B. In order to avoid a Warning: 'Divide by zero', the elements of y==0
% are substituded with a very small value (0.00001) 

function m = mediapondinv(x,y)

[a,b]=size(x);
[c,d]=size(y);
if b~=d
    error('le dimensioni non sono uguali')
end
for k=1:d
    if y(k)==0
        y(k)=0.00001;
    end
end    
m = (sum(x.*(1./y)))/(sum(1./y));
